#include	"stdio.h"
#include	"pwindow.h"
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwMand.h"

void	main()
{
	int			limit,x_cnt,y_cnt,cnt,step,mleft,mtop;
	double		x,y,r,c_step,r_start,i_start,zr,zi,cr,ci,dist,i;
	char		flg[2];
	PWGMAP		*mp;
	PWIN		*pw;
	
	PwInitWin();
	PwGetMousePosition(PwGetRootWin(),&mleft,&mtop);
	pw = PwCreateWin(PwGetRootWin(),mleft,mtop,320,205);
	PwSetWinAttr(pw,WIN_MP_TITLE|WIN_MP_SCREEN|WIN_SIZE|WIN_MP_SHADEB|\
				 WIN_MP_SHADER|WIN_SIZE);
	PwSetWinTitle(pw,"Mandelbrot Set");
	PwSetStdPath(pw,MSK_STDOUT|MSK_STDIN|MSK_STDERR);
	PwOpenWin(pw);

	if ((mp=PwCreateMap(200,200))==NULL){
		fprintf(stderr,"PwCreateMap error\n");
		exit(-1);
	}

	PwSetMapWin(mp,pw,1,1,200,200);
	PwSetFlushMode(mp,FLS_NORMAL);
	t_clear();

	flg[0] = 'y';
	while (flg[0] == 'y'){

		t_locate(CLMX,0);
		printf("l:");
		scanf("%d",&limit);

		t_locate(CLMX,1);
		printf("x:");
		scanf("%lf",&x);

		t_locate(CLMX,2);
		printf("y:");
		scanf("%lf",&y);

		t_locate(CLMX,3);
		printf("r:");
		scanf("%lf",&r);

		t_locate(CLMX,4);
		printf("s:");
		scanf("%d",&step);

		PwSetPenSize(mp,step,step);

		curoff();

		c_step = 2.0 * r / WIDTH;
		r_start = x - r;
		i_start = y + r;

		for (y_cnt = 1;y_cnt < WIDTH-1;y_cnt += step){
			for (x_cnt = 1;x_cnt < WIDTH-1;x_cnt += step){
				zr = 0.0;
				zi = 0.0;
				cr = r_start + c_step * (double)x_cnt;
				ci = i_start - c_step * (double)y_cnt;
				dist = 0.0;
				cnt = 0;
				while ((dist < 4.0) && (cnt < limit)){
					r = zr * zr - zi * zi + cr;
					i = 2.0 * zr * zi + ci;
					zr = r;
					zi = i;
					dist = zr * zr + zi * zi;
					cnt++;
				}
				if (cnt >= limit || (cnt%2) == 0){
					PwSetDrawMode(mp,DM_OR);
				}else{
					PwSetDrawMode(mp,DM_NOT);
				}
				PwDrawPoint(mp,x_cnt,y_cnt);
			}
		}

		curon();
		t_locate(CLMX,5);
		printf("cont(y/n):");
		scanf("%1s",flg);
	}
	PwDestroyMap(mp);
	PwCloseWin(pw);
	PwDestroyWin(pw);
	PwTermWin();
}
 
int	t_clear()
{
	printf("\033[1J");
	t_locate(0,0);
	return (0);
}

int	t_locate(x,y)
int	x;
int	y;
{
	x++;
	y++;

	printf("\033[%d;%dH",y,x);
	return (0);
}

int	curoff()
{
	printf("\033[1v");
	fflush(stdout);
	return 0;
}

int	curon()
{
	printf("\033[0v");
	fflush(stdout);
	return 0;
}
